Attribute VB_Name = "SubMain"
'------------------------------------------------------------------------------
'
'   ACTvZT[rX TvvO
'   X^[gAbvW[
'
'   Copyrights (c) 2004-2005 Advanced Core Technologies, Inc. All rights reserved.
'
'   2005/03/04 Rev.1.00 RIN J
'
'------------------------------------------------------------------------------

Option Explicit

'------------------------------------------------------------------------------
'   Win32 Structure
'------------------------------------------------------------------------------

Private Type FILETIME
    dwLowDateTime As Long
    dwHighDateTime As Long
End Type

'------------------------------------------------------------------------------
'   Win32 API
'------------------------------------------------------------------------------

'   [Private]

'   ANSI RegOpenKeyEx
Public Declare Function RegOpenKeyEx Lib "advapi32.dll" Alias "RegOpenKeyExA" ( _
    ByVal hKey As Long, _
    ByVal lpSubKey As String, _
    ByVal ulOptions As Long, _
    ByVal samDesired As Long, _
    phkResult As Long) As Long
'   ANSI RegEnumKeyEx
Public Declare Function RegEnumKeyEx Lib "advapi32.dll" Alias "RegEnumKeyExA" ( _
    ByVal hKey As Long, _
    ByVal dwIndex As Long, _
    ByVal lpName As String, _
    lpcbName As Long, _
    ByVal lpReserved As Long, _
    ByVal lpClass As String, _
    lpcbClass As Long, _
    lpftLastWriteTime As FILETIME) As Long
'   RegCloseKey
Public Declare Function RegCloseKey Lib "advapi32.dll" ( _
    ByVal hKey As Long) As Long
'   ANSI LoadLibrary
Public Declare Function LoadLibrary Lib "kernel32" Alias "LoadLibraryA" ( _
    ByVal lpLibFileName As String) As Long
'   FreeLibrary
Public Declare Function FreeLibrary Lib "kernel32" ( _
    ByVal hLibModule As Long) As Long

'------------------------------------------------------------------------------
'   Constants
'------------------------------------------------------------------------------

'   [Private]

'   Mapple X WXg
Private Const REGISTORY_KEY_MAIN_MAPPLEX As String = _
"SOFTWARE\Shobunsha\Product Keys"                               '   WXgL[
Private Const REGISTORY_COMPARE_STRING_MAPPLEX As String = _
"MPX*"                                                          '   WXg(For Install Check)

'   for Win32 API
Private Const HKEY_LOCAL_MACHINE As Long = &H80000002
Private Const KEY_ENUMERATE_SUB_KEYS As Long = &H8
Private Const ERROR_SUCCESS As Long = 0&
Private Const ENUM_MAX As Long = 255

Public g_hDWSBrdge As Long    '   DWSBrdge.dllnh

'   X^[gAbv
Sub Main()
    Dim hKey As Long                        '   TuL[nh
    Dim dwKeyIndex As Long                  '   TuL[̃CfbNXԍ
    Dim dwKeyNameMax As Long                '   TuL[obt@TCY
    Dim dwClassNameMax As Long              '   NXi[obt@TCY
    Dim szKeyName As String * ENUM_MAX      '   TuL[i[obt@
    Dim szClassName As String * ENUM_MAX    '   NXi[obt@
    Dim ftLastWriteTime As FILETIME         '   ŏIݎ
    Dim bSMDExist As Boolean                '   Mapple X CXg[tO
    
    '   
    dwKeyIndex = 0                      '   CfbNXԍ
    dwKeyNameMax = Len(szKeyName)       '   TuL[obt@TCY
    dwClassNameMax = Len(szClassName)   '   NXobt@TCY
    bSMDExist = False                   '   CXg[tO

    '   TuL[̃I[vɐH
    If RegOpenKeyEx(HKEY_LOCAL_MACHINE, REGISTORY_KEY_MAIN_MAPPLEX, 0, KEY_ENUMERATE_SUB_KEYS, hKey) = ERROR_SUCCESS Then
        Do
            '   TuL[ Mapple X CXg[Ă邩`FbN
            If RegEnumKeyEx(hKey, dwKeyIndex, szKeyName, dwKeyNameMax, 0, szClassName, dwClassNameMax, ftLastWriteTime) <> ERROR_SUCCESS Then
                Exit Do '   [v𔲂
            End If

            '   TuL[̐擪͈v邩H
            If szKeyName Like REGISTORY_COMPARE_STRING_MAPPLEX Then
                bSMDExist = True    '   ݃tO
                Exit Do '   [v𔲂
            End If
            '   
            dwKeyNameMax = Len(szKeyName)       '   TuL[obt@TCY
            dwClassNameMax = Len(szClassName)   '   NXobt@TCY
            dwKeyIndex = dwKeyIndex + 1         '   ̃CfbNXԍ
        Loop
        RegCloseKey hKey    '   TuL[̃N[Y
    Else
        MsgBox "WXgJ܂B" + vbCrLf + "AvP[VI܂B", vbOKOnly + vbCritical, "G["
        End '   AvP[V̏I
    End If
    '   WXg͌H
    If bSMDExist = False Then
        MsgBox "MappleXCXg[Ă܂B" + vbCrLf + "AvP[VI܂B", vbOKOnly + vbCritical, "G["
        End '   AvP[V̏I
    End If

    On Error GoTo ErrHandler
        '   DWSBrdge.dllnh̃[h
        g_hDWSBrdge = LoadLibrary(App.Path & "\DWSBrdge.dll")
        '   [hłH
        If g_hDWSBrdge = 0 Then
            MsgBox "DWSBrdge.dll[hł܂B" + vbCrLf + "AvP[VI܂B", vbOKOnly + vbCritical, "G["
            End '   AvP[V̏I
        End If
        MainForm.Show   '   CtH[̕\
    Exit Sub

'   CZX̃`FbN̑̃`FbN
ErrHandler:
    MsgBox Err.Description
    FreeLibrary g_hDWSBrdge
    
End Sub



'   End of Source
